function TankMasteryFrame_OnLoad()
	TankMasteryFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	ChatFrame1:AddMessage("|cffffff00TankMastery Loaded (v0.1)");
	TankMasteryFrame:Hide();
end


local taunts = {
	355,   -- Warrior: Taunt
	1161,  -- Warrior: Challenging Shout
	5209,  -- Druid: Challanging Roar
	6795,  -- Druid: Growl
	27270, -- VoidWalker: Torment Rank 7 
	31789, -- Paladin: Righteous Defense
	33700, -- Felguard: Anguish Rank 3
	33701, -- VoidWalker: Suffering Rank 6
	47984, -- VoidWalker: Torment Rank 8
	47989, -- VoidWalker: Suffering Rank 7
	47990, -- VoidWalker: Suffering Rank 8
	47993, -- Felguard: Anguish Rank 4
	56222, -- DK: Dark Command
	59671, -- Warlock: Challanging Howl
	62124, -- Paladin: Hand of Reckoning
}

local mocks = {	
	694,   -- Warrior: Mocking Blow
	49576, -- DK: Death Grip
}

local knockbacks = {
	53227, -- Druid: Typhoon
	59159, -- Shaman: Thunderstorm
}

function TableContainsValue(table, value)
        if (table and value) then
                for _, v in ipairs(table) do
                        if (v == value) then
                                return true;
                        end
                end
                return false;
        end
end


function TankMasteryFrame_OnEvent(event, ...)

	local timestamp, ttype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellid, spellname, spellschool, b_or_d = select(1, ...);
	local tauntmsg = "";
	local isAOE = false;

	if (ttype == "SPELL_CAST_SUCCESS") and (UnitGUID("targettarget")) and (UnitGUID("target")) and (UnitGUID("targettarget") == UnitGUID("player")) and (UnitGUID("player") ~= srcGUID) then
--		if (dstName == "" dstName == null or (not CombatLog_Object_IsA(dstFlags, COMBATLOG_OBJECT_TYPE_PLAYER))) then
			if ((dstName == nil or dstName == "") and UnitName("target")) then			
				dstName = UnitName("target");
				isAOE = true;
			end

			-- taunts etc
			if (TableContainsValue(taunts, spellid)) then
				if (not isAOE) then -- only my target
					if (UnitGUID("target") == dstGUID) then
						-- ChatFrame1:AddMessage(srcName.." has taunted "..dstName.." of me using "..spellname..".");
						tauntmsg = srcName.." taunted "..dstName.." using "..spellname..".";
					end
				else
					tauntmsg = srcName.." taunted "..dstName.." using AOE "..spellname..".";
				end
			end

			-- mocks etc
			if (TableContainsValue(mocks, spellid)) then
				tauntmsg = srcName.." mocked "..dstName.." using "..spellname..".";
			end	

			-- knockback etc
			if (TableContainsValue(knockbacks, spellid)) then
				tauntmsg = srcName.." knocked-away "..dstName.." using "..spellname..".";
			end	

			if (tauntmsg ~= "") then		
				  if GetNumRaidMembers() ~= 0 then
					SendChatMessage(""..tauntmsg, "RAID")
				  elseif GetNumPartyMembers() ~= 0 then
					SendChatMessage(""..tauntmsg, "PARTY")
				  end
			end
--		end
	end
end

